<?php header("Content-type: text/html; charset=UTF-8");?>
<?php
/**
* @package	RS Membership for Joomla!
* @copyright	Copyright (C) 2015 Afzoneha.ir Mohamad Deljou
* @license		do not copy please. for order or technical support call me at 09355384337
* @autor url    http://www.Afzoneha.ir/
* @autor email  info@afzoneha.ir
* @Developer    Mohamad Deljou - www.Afzoneha.ir
*/
error_reporting(0);
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.html.parameter' );

if (! defined('DS') ) define('DS', DIRECTORY_SEPARATOR);

if (file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php'))
	require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');

class plgSystemRSMembershipbitpay extends JPlugin
{
	function canRun()
	{
		return file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');
	}

	function plgSystemRSMembershipbitpay(&$subject, $config)
	{
		parent::__construct($subject, $config);
		//$this->_plugin =& JPluginHelper::getPlugin('system', 'rsmembershipbitpay');
		//$this->_params = new JParameter($this->_plugin->params);
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rsmembershipbitpay');
		$this->_params = json_decode($this->_plugin->params);
		if (!$this->canRun()) return;
		RSMembership::addPlugin('پرداخت آنلاین', 'rsmembershipbitpay');
	}
	public function onAfterRender()
	{
		if(isset($_POST['trans_id']) && isset($_POST['id_get']))
		{
			$this->onPaymentNotification();
		}
	}
	function onMembershipPayment($plugin, $data, $extra, $membership, $transaction)
	{
		if (!$this->canRun()) return;
		if ($plugin != $this->_plugin->name) return false;

		$transaction->custom = time();
		$url = 'https://bitpay.ir/payment/gateway-send';
		$api = $this->_params->api;
		$amount = $transaction->price;
		$redirect = urlencode(JURI::base().'index.php?option=com_rsmembership&task=thankyou&oID='.$transaction->custom);
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
		curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$result = curl_exec($ch);
		curl_close($ch);
		if ($result>0 && is_numeric($result))
		{
			$html = '<form name="frmPay" method="get" action="https://bitpay.ir/payment/gateway-'.$result.'">
						<center>
						<noscript>
						<p style="font:bold 12px tahoma; color:#FF0000; direction:rtl; text-align:center;">در صورتیکه بعد از گذشت 5 ثانیه به درگاه بانکی وصل نشده اید ؛ بر روی دکمه ی زیر کلیک کنید.</p>
						<input type="submit" value="پرداخت" style="font:bold 12px tahoma; color:#FF0000; direction:rtl; text-align:center;" />
						</noscript>
						</center>
					</form>
					<script>document.frmPay.submit();</script>';
		}
		else
		{
			$html = 'خطا (ی شماره '.$result.') در دریافت اطلاعات پرداخت از سوی بانک. ';
			switch ($result)
			{
				case '-1':
					$html .= 'api ارسالی با نوع api تعریف شده در bitpay سازگار نیست.';
					break;
				case '-2':
					$html .= 'مقدار amount داده عددي نمی باشد و یا کمتر از 1000 ریال است.';
					break;
				case '-3':
					$html .= 'مقدار redirect رشته null است.';
					break;
				case '-4':
					$html .= 'درگاهی با اطلاعات ارسالی شما یافت نشده و یا در حالت انتظار می باشد.';
					break;
			}
		}
		echo ($html);
		return $html;
	}
	public function onPaymentNotification()
	{
		header('Content-Type: text/html; charset=utf-8');
		if ( !$this->canRun( ) )
		{
			echo ('خطا در اجرای ماژول');
		}
		else
		{
			$oID      = isset($_REQUEST['oID'])   ? $_REQUEST['oID']   : '';
			$trans_id = isset($_POST['trans_id']) ? $_POST['trans_id'] : '';
			//Afzoneha.ir
			$id_get   = isset($_POST['id_get'])   ? $_POST['id_get']   : '';
			$database = JFactory::getDBO();
			$database->setQuery( "SELECT * FROM #__rsmembership_transactions WHERE `custom`='".$oID."' AND `status`!='completed' AND `gateway`='پرداخت آنلاین'" );
			$transaction = $database->loadObject( );
			if ( empty( $transaction ) )
			{
				echo 'سفارش معتبر نیست . مبلغ پرداختی به حساب شما بازگشت داده می شود.';
				exit;die;
			}
			else
			{
				$url = 'https://bitpay.ir/payment/gateway-result-second';
				$api = $this->_params->api;
				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL,$url);
				curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				//Afzoneha.ir
				curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
				$result = curl_exec($ch);
				curl_close($ch);
				if ($result == '1')
				{
					$database->setQuery( "UPDATE #__rsmembership_transactions SET `hash`='".$trans_id."' , `status`='completed' WHERE `id`='".$transaction->id."' LIMIT 1" );
					$database->query();
					RSMembership::approve($transaction->id, true);
					echo ('<p style="font:bold 12px tahoma; color:#FF0000; direction:rtl; text-align:center;">پرداخت با موفقیت انجام شد.<br />شماره پیگیری : '.$trans_id.'<br /><a href="./?">برای ادامه کلیک کنید.</a></p>');
					exit;die;
				}
				else
				{
					echo('نتیجه استعلام پرداخت شما معتبر نیست. ');
					switch ($result)
					{
						case '-1' :
							echo 'api ارسالی با نوع api تعریف شده در bitpay سازگار نیست.';
							break;
						case '-2' :
							echo 'trans_id ارسال شده معتبر نمی باشد.';
							break;
						case '-3' :
							echo 'id_get ارسالی معتبر نمی باشد.';
							break;
						case '-4' :
							echo 'چنین تراکنشی در سیستم وجود ندارد و یا موفقیت آمیز نبوده است.';
							break;
					}
					exit;die;
				}
			}
		}
	}
}